<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit ("Do not access this file directly.");
/*
Function that saves all options from any page.
Options can also be passed in directly.
	Can also be self-verified.
*/
if (!function_exists ("ws_plugin__qcache_update_all_options"))
	{
		function ws_plugin__qcache_update_all_options ($new_options = FALSE, $verified = FALSE, $update_other = TRUE, $display_notices = TRUE, $enqueue_notices = FALSE, $request_refresh = FALSE)
			{
				do_action ("ws_plugin__qcache_before_update_all_options", get_defined_vars ()); /* If you use this Hook, be sure to use `wp_verify_nonce()`. */
				/**/
				if ($verified || ( ($nonce = $_POST["ws_plugin__qcache_options_save"]) && wp_verify_nonce ($nonce, "ws-plugin--qcache-options-save")))
					{
						if (!is_multisite () || (is_main_site () && is_super_admin ())) /* If Multisite, this MUST be ( Main Site / Super Admin ). */
							{
								$options = $GLOBALS["WS_PLUGIN__"]["qcache"]["o"]; /* Here we get all of the existing options. */
								$new_options = (is_array ($new_options)) ? $new_options : (array)$_POST; /* Force array. */
								$new_options = ws_plugin__qcache_trim_deep (stripslashes_deep ($new_options));
								/**/
								foreach ((array)$new_options as $key => $value) /* Looking for relevant keys. */
									if (preg_match ("/^" . preg_quote ("ws_plugin__qcache_", "/") . "/", $key))
										/**/
										if ($key === "ws_plugin__qcache_configured") /* Configured. */
											{
												update_option ("ws_plugin__qcache_configured", $value);
												$GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["configured"] = $value;
											}
										else /* Place this option into the array. Remove ws_plugin__qcache_. */
											{
												(is_array ($value)) ? array_shift ($value) : null; /* Arrays should be padded. */
												$key = preg_replace ("/^" . preg_quote ("ws_plugin__qcache_", "/") . "/", "", $key);
												$options[$key] = $value; /* Overriding a possible existing option. */
											}
								/**/
								$options["options_version"] = $options["options_version"] + 0.001;
								$options = ws_plugin__qcache_configure_options_and_their_defaults ($options);
								/**/
								eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
								do_action ("ws_plugin__qcache_during_update_all_options", get_defined_vars ());
								unset ($__refs, $__v); /* Unset defined __refs, __v. */
								/**/
								update_option ("ws_plugin__qcache_options", $options);
								/**/
								if ($update_other && $options["enabled"])
									{
										if (ws_plugin__qcache_add_wp_cache ()) /* Add WP_CACHE to the config file. */
											if (ws_plugin__qcache_add_advanced ()) /* Add the advanced-cache.php file. */
												if (ws_plugin__qcache_add_garbage_collector ()) /* Add the garbage collector. */
													if (ws_plugin__qcache_schedule_cache_dir_purge ()) /* Purge the cache. */
														{
															$enabled = true; /* Mark this variable as enabled successfully. */
															($options["auto_cache_enabled"]) ? ws_plugin__qcache_add_auto_cache_engine () : ws_plugin__qcache_delete_auto_cache_engine ();
															if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Options saved</strong>, and the cache was reset to avoid conflicts.' . (($request_refresh) ? ' Please <a href="' . esc_attr ($_SERVER["REQUEST_URI"]) . '">refresh</a>.' : '') . ''))
																($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice) : ws_plugin__qcache_display_admin_notice ($notice);
														}
										/**/
										if (!$enabled) /* Otherwise, we need to throw a warning up. The site owner needs to try again. */
											{
												if (!function_exists ("wp_cron")) /* Special warning for lack of the wp_cron function. */
													{
														if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Error:</strong> Could NOT enable Quick Cache. Your installation of WordPress® is missing the <code>wp_cron</code> function. Some web hosts disable this intentionally. Please contact your web host for assistance.'))
															($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice, false, true) : ws_plugin__qcache_display_admin_notice ($notice, true);
													}
												else /* Otherwise, the error must have something to do with file/directory permissions. */
													{
														if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Error:</strong> Could NOT enable Quick Cache. Please check permissions on <code>/wp-config.php</code>, <code>/wp-content/</code> and <code>/wp-content/cache/</code>. Permissions need to be <code>755</code> or higher.'))
															($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice, false, true) : ws_plugin__qcache_display_admin_notice ($notice, true);
													}
											}
									}
								/**/
								else if ($update_other && !$options["enabled"])
									{
										if (ws_plugin__qcache_delete_wp_cache ()) /* Delete WP_CACHE from the config file. */
											if (ws_plugin__qcache_delete_advanced ()) /* Delete the advanced-cache.php file. */
												if (ws_plugin__qcache_delete_garbage_collector ()) /* Delete the garbage collector. */
													if (ws_plugin__qcache_schedule_cache_dir_purge ()) /* Purge the cache. */
														{
															$disabled = true; /* Mark this variable as disabled successfully. */
															ws_plugin__qcache_delete_auto_cache_engine (); /* Delete Auto-Cache. */
															if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Options saved.</strong> Quick Cache disabled.' . (($request_refresh) ? ' Please <a href="' . esc_attr ($_SERVER["REQUEST_URI"]) . '">refresh</a>.' : '') . ''))
																($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice) : ws_plugin__qcache_display_admin_notice ($notice);
														}
										/**/
										if (!$disabled) /* Otherwise, we need to throw a warning up. The site owner needs to try again. */
											{
												if (!function_exists ("wp_cron")) /* Special warning for lack of the wp_cron function. */
													{
														if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Error:</strong> Could NOT disable Quick Cache. Your installation of WordPress® is missing the <code>wp_cron</code> function. Some web hosts disable this intentionally. Please contact your web host for assistance.'))
															($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice, false, true) : ws_plugin__qcache_display_admin_notice ($notice, true);
													}
												else /* Otherwise, the error must have something to do with file/directory permissions. */
													{
														if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Error:</strong> Could NOT disable Quick Cache. Please check permissions on <code>/wp-config.php</code>, <code>/wp-content/</code> and <code>/wp-content/cache/</code>. Permissions need to be <code>755</code> or higher.'))
															($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice, false, true) : ws_plugin__qcache_display_admin_notice ($notice, true);
													}
											}
									}
								else if (!$update_other) /* Not updating anything else. We just need to display a notice that options have been saved successfully */
									{
										if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = '<strong>Options saved.' . (($request_refresh) ? ' Please <a href="' . esc_attr ($_SERVER["REQUEST_URI"]) . '">refresh</a>.' : '') . '</strong>'))
											($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice) : ws_plugin__qcache_display_admin_notice ($notice);
									}
							}
						else /* Else, a security warning needs to be issued. Only Super Administrators are allowed to modify Quick Cache ( operating on the Main Site ). */
							{
								if (($display_notices === true || in_array ("success", (array)$display_notices)) && ($notice = 'Quick Cache can ONLY be modified by a Super Administrator, while operating on the Main Site.'))
									($enqueue_notices === true || in_array ("success", (array)$enqueue_notices)) ? ws_plugin__qcache_enqueue_admin_notice ($notice, false, true) : ws_plugin__qcache_display_admin_notice ($notice, true);
							}
					}
				/**/
				do_action ("ws_plugin__qcache_after_update_all_options", get_defined_vars ());
				/**/
				return; /* Return for uniformity. */
			}
	}
/*
Add the options menus & sub-menus.
Attach to: add_action("admin_menu");
*/
if (!function_exists ("ws_plugin__qcache_add_admin_options"))
	{
		function ws_plugin__qcache_add_admin_options ()
			{
				do_action ("ws_plugin__qcache_before_add_admin_options", get_defined_vars ());
				/**/
				if (!is_multisite () || (is_multisite () && is_main_site () && is_super_admin ()))
					{
						add_filter ("plugin_action_links", "_ws_plugin__qcache_add_settings_link", 10, 2);
						/**/
						if (apply_filters ("ws_plugin__qcache_during_add_admin_options_create_menu_items", true, get_defined_vars ()))
							{
								add_menu_page ("Quick Cache", "Quick Cache", "edit_plugins", "ws-plugin--qcache-options", "ws_plugin__qcache_options_page");
								/**/
								if (apply_filters ("ws_plugin__qcache_during_add_admin_options_add_options_page", true, get_defined_vars ()))
									add_submenu_page ("ws-plugin--qcache-options", "Quick Cache Config Options", "Config Options", "edit_plugins", "ws-plugin--qcache-options", "ws_plugin__qcache_options_page");
								/**/
								if (apply_filters ("ws_plugin__qcache_during_add_admin_options_add_info_page", true, get_defined_vars ()))
									add_submenu_page ("ws-plugin--qcache-options", "Quick Cache Info", "Quick Cache Info", "edit_plugins", "ws-plugin--qcache-info", "ws_plugin__qcache_info_page");
							}
					}
				else /* Else we need to hide Quick Cache from the plugins menu. */
					{
						add_filter ("all_plugins", "_ws_plugin__qcache_hide_from_plugins_menu");
					}
				/**/
				do_action ("ws_plugin__qcache_after_add_admin_options", get_defined_vars ());
				/**/
				return;
			}
	}
/*
A sort of callback function to add the settings link.
Attach to: add_filter("plugin_action_links");
*/
if (!function_exists ("_ws_plugin__qcache_add_settings_link"))
	{
		function _ws_plugin__qcache_add_settings_link ($links = array (), $file = "")
			{
				eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
				do_action ("_ws_plugin__qcache_before_add_settings_link", get_defined_vars ());
				unset ($__refs, $__v); /* Unset defined __refs, __v. */
				/**/
				if (preg_match ("/" . preg_quote ($file, "/") . "$/", $GLOBALS["WS_PLUGIN__"]["qcache"]["l"]) && is_array ($links))
					{
						$settings = '<a href="admin.php?page=ws-plugin--qcache-options">Settings</a>';
						array_unshift ($links, $settings);
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("_ws_plugin__qcache_during_add_settings_link", get_defined_vars ());
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
					}
				/**/
				return apply_filters ("_ws_plugin__qcache_add_settings_link", $links, get_defined_vars ());
			}
	}
/*
A sort of callback function to hide Quick Cache from plugins menu.
Attach to: add_filter("all_plugins");
*/
if (!function_exists ("_ws_plugin__qcache_hide_from_plugins_menu"))
	{
		function _ws_plugin__qcache_hide_from_plugins_menu ($plugins = FALSE)
			{
				eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
				do_action ("_ws_plugin__qcache_before_hide_from_plugins_menu", get_defined_vars ());
				unset ($__refs, $__v); /* Unset defined __refs, __v. */
				/**/
				foreach ($plugins as $file => $plugin)
					if (preg_match ("/" . preg_quote ($file, "/") . "$/", $GLOBALS["WS_PLUGIN__"]["qcache"]["l"]))
						unset ($plugins[$file]);
				/**/
				return apply_filters ("_ws_plugin__qcache_hide_from_plugins_menu", $plugins, get_defined_vars ());
			}
	}
/*
Add header controls to the admin panel.
Attach to: add_action("in_admin_header");
*/
if (!function_exists ("ws_plugin__qcache_add_admin_header_controls"))
	{
		function ws_plugin__qcache_add_admin_header_controls ()
			{
				do_action ("ws_plugin__qcache_before_add_admin_header_controls", get_defined_vars ());
				/**/
				if (!is_multisite () || (is_multisite () && is_super_admin ()))
					{
						echo '<form style="float:right; margin:11px 11px 0 11px;" onsubmit="return false;">' . "\n";
						echo '<input type="button" id="ws-plugin--qcache-ajax-clear" style="outline:none; min-width:115px; padding-left:22px; padding-right:5px; background-repeat:no-repeat; background-position:5px center; background-image:url(\'' . ws_plugin__qcache_esc_sq ($GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"]) . '/images/ajax-clear.png\');" value="Clear Cache" title="Clear Cache Manually" onclick="jQuery (this).css (\'background-image\', \'url(\\\'' . ws_plugin__qcache_esc_sq ($GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"]) . '/images/ajax-loader.gif\\\')\'); jQuery.post (ajaxurl, {action: \'ws_plugin__qcache_ajax_clear\', ws_plugin__qcache_ajax_clear: \'' . ws_plugin__qcache_esc_sq (wp_create_nonce ("ws-plugin--qcache-ajax-clear")) . '\'}, function (response){ eval (response); });" />' . "\n";
						echo '</form>';
						/**/
						do_action ("ws_plugin__qcache_during_add_admin_header_controls", get_defined_vars ());
					}
				/**/
				do_action ("ws_plugin__qcache_after_add_admin_header_controls", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Add scripts to admin panels.
Attach to: add_action("admin_print_scripts");
*/
if (!function_exists ("ws_plugin__qcache_add_admin_scripts"))
	{
		function ws_plugin__qcache_add_admin_scripts ()
			{
				do_action ("ws_plugin__qcache_before_add_admin_scripts", get_defined_vars ());
				/**/
				if ($_GET["page"] && preg_match ("/ws-plugin--qcache-/", $_GET["page"]))
					{
						wp_enqueue_script ("jquery");
						wp_enqueue_script ("thickbox");
						wp_enqueue_script ("media-upload");
						wp_enqueue_script ("jquery-ui-core");
						wp_enqueue_script ("jquery-json-ps", $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"] . "/includes/menu-pages/jquery-json-ps-min.js", array ("jquery"), $GLOBALS["WS_PLUGIN__"]["qcache"]["o"]["options_version"] . $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["filemtime"]);
						wp_enqueue_script ("jquery-ui-effects", $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"] . "/includes/menu-pages/jquery-ui-effects.js", array ("jquery", "jquery-ui-core"), $GLOBALS["WS_PLUGIN__"]["qcache"]["o"]["options_version"] . $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["filemtime"]);
						wp_enqueue_script ("ws-plugin--qcache-menu-pages", get_bloginfo ("wpurl") . "/?ws_plugin__qcache_menu_pages_js=1", array ("jquery", "thickbox", "media-upload", "jquery-json-ps", "jquery-ui-core", "jquery-ui-effects"), $GLOBALS["WS_PLUGIN__"]["qcache"]["o"]["options_version"] . $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["filemtime"]);
						/**/
						do_action ("ws_plugin__qcache_during_add_admin_scripts", get_defined_vars ());
					}
				/**/
				do_action ("ws_plugin__qcache_after_add_admin_scripts", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Add styles to admin panels.
Attach to: add_action("admin_print_styles");
*/
if (!function_exists ("ws_plugin__qcache_add_admin_styles"))
	{
		function ws_plugin__qcache_add_admin_styles ()
			{
				do_action ("ws_plugin__qcache_before_add_admin_styles", get_defined_vars ());
				/**/
				if ($_GET["page"] && preg_match ("/ws-plugin--qcache-/", $_GET["page"]))
					{
						wp_enqueue_style ("thickbox");
						wp_enqueue_style ("ws-plugin--qcache-menu-pages", get_bloginfo ("wpurl") . "/?ws_plugin__qcache_menu_pages_css=1", array ("thickbox"), $GLOBALS["WS_PLUGIN__"]["qcache"]["o"]["options_version"] . $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["filemtime"], "all");
						/**/
						do_action ("ws_plugin__qcache_during_add_admin_styles", get_defined_vars ());
					}
				/**/
				do_action ("ws_plugin__qcache_after_add_admin_styles", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Function that outputs the js for menu pages.
Attach to: add_action("init");
*/
if (!function_exists ("ws_plugin__qcache_menu_pages_js"))
	{
		function ws_plugin__qcache_menu_pages_js ()
			{
				do_action ("ws_plugin__qcache_before_menu_pages_js", get_defined_vars ());
				/**/
				if ($_GET["ws_plugin__qcache_menu_pages_js"] && is_user_logged_in () && current_user_can ("edit_plugins"))
					{
						header ("Content-Type: text/javascript; charset=utf-8");
						header ("Expires: " . gmdate ("D, d M Y H:i:s", strtotime ("-1 week")) . " GMT");
						header ("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
						header ("Cache-Control: no-cache, must-revalidate, max-age=0");
						header ("Pragma: no-cache");
						/**/
						$u = $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"];
						$i = $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"] . "/images";
						/**/
						include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages-min.js";
						/**/
						echo "\n"; /* Add a line break before inclusion of this file. */
						/**/
						@include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages-s-min.js";
						/**/
						do_action ("ws_plugin__qcache_during_menu_pages_js", get_defined_vars ());
						/**/
						exit ();
					}
				/**/
				do_action ("ws_plugin__qcache_after_menu_pages_js", get_defined_vars ());
			}
	}
/*
Function that outputs the css for menu pages.
Attach to: add_action("init");
*/
if (!function_exists ("ws_plugin__qcache_menu_pages_css"))
	{
		function ws_plugin__qcache_menu_pages_css ()
			{
				do_action ("ws_plugin__qcache_before_menu_pages_css", get_defined_vars ());
				/**/
				if ($_GET["ws_plugin__qcache_menu_pages_css"] && is_user_logged_in () && current_user_can ("edit_plugins"))
					{
						header ("Content-Type: text/css; charset=utf-8");
						header ("Expires: " . gmdate ("D, d M Y H:i:s", strtotime ("-1 week")) . " GMT");
						header ("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
						header ("Cache-Control: no-cache, must-revalidate, max-age=0");
						header ("Pragma: no-cache");
						/**/
						$u = $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"];
						$i = $GLOBALS["WS_PLUGIN__"]["qcache"]["c"]["dir_url"] . "/images";
						/**/
						ob_start ("ws_plugin__qcache_compress_css"); /* Compress. */
						/**/
						include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages.css";
						/**/
						echo "\n"; /* Add a line break before inclusion of this file. */
						/**/
						@include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages-s.css";
						/**/
						do_action ("ws_plugin__qcache_during_menu_pages_css", get_defined_vars ());
						/**/
						exit ();
					}
				/**/
				do_action ("ws_plugin__qcache_after_menu_pages_css", get_defined_vars ());
			}
	}
/*
Function for building and handling the options page.
*/
if (!function_exists ("ws_plugin__qcache_options_page"))
	{
		function ws_plugin__qcache_options_page ()
			{
				do_action ("ws_plugin__qcache_before_options_page", get_defined_vars ());
				/**/
				ws_plugin__qcache_update_all_options () . clearstatcache ();
				/**/
				if (file_exists (ABSPATH . "wp-config.php") && !is_writable (ABSPATH . "wp-config.php"))
					{
						ws_plugin__qcache_display_admin_notice ('<strong>Permissions:</strong> Please check permissions on <code>' . esc_html (preg_replace ("/^" . preg_quote ($_SERVER["DOCUMENT_ROOT"], "/") . "/", "", ABSPATH . "wp-config.php")) . '</code>. Quick Cache needs write-access to this file. Permissions need to be <code>755</code> or higher.', true);
					}
				else if (file_exists (dirname (ABSPATH) . "/wp-config.php") && !is_writable (dirname (ABSPATH) . "/wp-config.php"))
					{
						ws_plugin__qcache_display_admin_notice ('<strong>Permissions:</strong> Please check permissions on <code>' . esc_html (preg_replace ("/^" . preg_quote ($_SERVER["DOCUMENT_ROOT"], "/") . "/", "", dirname (ABSPATH) . "/wp-config.php")) . '</code>. Quick Cache needs write-access to this file. Permissions need to be <code>755</code> or higher.', true);
					}
				if (is_dir (WP_CONTENT_DIR) && !is_writable (WP_CONTENT_DIR))
					{
						ws_plugin__qcache_display_admin_notice ('<strong>Permissions:</strong> Please check permissions on <code>' . esc_html (preg_replace ("/^" . preg_quote ($_SERVER["DOCUMENT_ROOT"], "/") . "/", "", WP_CONTENT_DIR)) . '</code>. Quick Cache needs write-access to this directory. Permissions need to be <code>755</code> or higher.', true);
					}
				if (is_dir (WP_CONTENT_DIR . "/cache") && !is_writable (WP_CONTENT_DIR . "/cache"))
					{
						ws_plugin__qcache_display_admin_notice ('<strong>Permissions:</strong> Please check permissions on <code>' . esc_html (preg_replace ("/^" . preg_quote ($_SERVER["DOCUMENT_ROOT"], "/") . "/", "", WP_CONTENT_DIR . "/cache")) . '</code>. Quick Cache needs write-access to this directory. Permissions need to be <code>755</code> or higher.', true);
					}
				/**/
				include_once dirname (dirname (__FILE__)) . "/menu-pages/options.inc.php";
				/**/
				do_action ("ws_plugin__qcache_after_options_page", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Function for building and handling the info page.
*/
if (!function_exists ("ws_plugin__qcache_info_page"))
	{
		function ws_plugin__qcache_info_page ()
			{
				do_action ("ws_plugin__qcache_before_info_page", get_defined_vars ());
				/**/
				include_once dirname (dirname (__FILE__)) . "/menu-pages/info.inc.php";
				/**/
				do_action ("ws_plugin__qcache_after_info_page", get_defined_vars ());
				/**/
				return;
			}
	}
?>